class Tag
  include Mongoid::Document
  include Mongoid::Timestamps

  field :name, localize: true
  field :is_default, type: Boolean, default: false

  has_many :taggings, dependent: :destroy
  has_and_belongs_to_many :module_app

  def show_names_slash
    span_names = []
    Site.first.in_use_locales.each do |locale| 
      span_names << "<span class='tag'>#{self.name_translations[locale]}</span>"
    end
    span_names.join(" / ").html_safe
  end

  def get_module_tagging_count(model)
    Tagging.where(:tag=>self.id, :taggable_type=>model).count
  end

end
